<%@page language="java" import="java.sql.*,java.util.*" %>
<%
/**
 *     Caption: Zaval Database Front-end
 *     $Revision: 1.32 $
 *     $Date: 2001/12/24 20:12:10 $
 *
 *     @author:     Alexander Ivanyukovich
 *     @version:    1.0
 *
 * The Zaval Database Front-end provides end users with a light database 
 * query tool for databases that have JDBC-compliant drivers using Web 
 * interface. This tool is dedicated for software developers and 
 * database administrators.
 * 
 * For more info on this product read Zaval Database Front-End User's Guide
 * (It comes within this package).
 * The latest product version is always available from the product homepage:
 * http://www.zaval.org/products/db-front-end/
 * or from SourceForge:
 * http://sourceforge.net/projects/zaval0000/
 *
 * Contacts:
 *   Author : a.ivanyukovich@zaval.org
 *   Support : support@zaval.org
 *   Change Requests : change-request@zaval.org
 * 
 * Copyright (C) 2001  Zaval Creative Engineering Group (http://www.zaval.org)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * (version 2) as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

/**
 * In most databases you can execute several queries as one.
 * But there are databases that do not allow this functionality.
 * To make life easier we just parse input query and take it to pieces.
 * Each subquery is executed separately.
 * QUERY_DELIMITER constant is a delimiter symbol between subqueries.
 */
char QUERY_DELIMITER = ';';
/**
 * To set browser encoding (via <meta>) we use pageEncoding array.
 * It can be customized if needed.
 */
String [] pageEncodings = new String[2];
pageEncodings[0] = "ISO-8859-1";
pageEncodings[1] = "Windows-1251";

/**
 * While experimenting with various jdbc drivers we faced with a problem of national characters suport.
 * The most flexible way is to allow user choose the appropriate encodings - both database internal and actual.
 * Once set, encodings are saved the same between queries.
 */
String [] javaEncodings = new String[5];
javaEncodings[0] = "ISO-8859-1";
javaEncodings[1] = "US-ASCII";
javaEncodings[2] = "UTF-8";
javaEncodings[3] = "UTF-16";
javaEncodings[4] = "Cp1251";

String query = new String("");
/**
 * Let's initialise all encodings.
 * dbEnc - is an internal database encoding.
 * outEnc - is an internal java encoding we used to represent String object.
 * pageEnc - is a browser encoding (we set it via <meta> tag).
 * If they are not specified set them to default values.
*/
String dbEnc, outEnc, pageEnc;
if(request.getParameter("dbEnc") != null)
    dbEnc = request.getParameter("dbEnc");
else
    dbEnc = javaEncodings[0];
if(request.getParameter("outEnc") != null)
    outEnc = request.getParameter("outEnc");
else
    outEnc = javaEncodings[0];
if(request.getParameter("pageEnc") != null)
    pageEnc = request.getParameter("pageEnc");
else
    pageEnc = pageEncodings[0];
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
    <title>Zaval Database Front-end</title>
    <meta name="description" content="Zaval Database Front-end (http://www.zaval.org)" />
    <meta http-equiv="Content-Type" content="text/html; charset=<%= pageEnc %>" />
    <style>
        .login { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 8pt; color: #666666; width:320px; }
        .header { font-family:Verdana, Arial, Helvetica, sans-serif; font-size: 10pt; color: #666666; font-weight: bold; }
        .tableHeader { background-color: #c0c0c0; color: #666666;}
        .tableHeaderLight { background-color: #cccccc; color: #666666;}
        .main { font-family:Verdana, Arial, Helvetica, sans-serif; font-size: 8pt; color: #666666;}
        .copy { font-family:Verdana, Arial, Helvetica, sans-serif; font-size: 8pt; color: #999999;}
        .copy:Hover { color: #666666; text-decoration : underline; }
        td { font-family:Verdana, Arial, Helvetica, sans-serif; font-size: 8pt; color: #666666;}
        A { text-decoration: none; }
        A:Hover { color : Red; text-decoration : underline; }
        BODY { OVERFLOW: auto; font-family:Verdana, Arial, Helvetica, sans-serif; font-size: 8pt; color: #666666; }
    </style>
    <script language="JavaScript">
        function completeFields(val, id){
            document.forms[0].elements[id].value = val;
        }
    </script>
</head>
<body bgcolor="#FFFFFF">
    <center>
        <H2>Zaval Database Front-end</H2>
    </center>
<%
// we store connection in the session, so we cut connection expences down.
if(session.getValue("connection") == null){
    //lets check whether user passed to script url for the connection otherwise show login page.
    if(request.getParameter("url") == null || request.getParameter("url").toString().trim().length() == 0){
%>
    <center>
        <table border="0" cellpadding="0" cellspacing="0">
            <form action="index.jsp" method="post">
            <tr>
                <td align="right">Driver :</td>
                <td align="right">&nbsp;&nbsp;</td>
                <td align="left" colspan="2"><input class="login" type="Text" name="driver" value="sun.jdbc.odbc.JdbcOdbcDriver" size="50"></td>
            </tr>
            <tr>
                <td align="right">URL :</td>
                <td align="right">&nbsp;&nbsp;</td>
                <td align="left" colspan="2"><input class="login" type="Text" name="url" value="jdbc:odbc:" size="50"></td>
            </tr>
            <tr>
                <td align="right">login :</td>
                <td align="right">&nbsp;</td>
                <td align="left" colspan="2"><input class="login" type="Text" name="login" value="" size="50"></td>
            </tr>
            <tr>
                <td align="right">password :</td>
                <td align="right">&nbsp;</td>
                <td align="left" colspan="2"><input class="login" type="Password" name="password" value="" size="50"></td>
            </tr>
            <tr>
                <td align="right" colspan="2">&nbsp;</td>
                <td align="left"><input class="main" type="Submit" value="Login"></td>
                <td align="right"><a href="http://www.zaval.org/products/db-front-end/user_guide/">Help</a>&nbsp;&nbsp;&nbsp;<a href="http://www.zaval.org/products/db-front-end/">Homepage</a></td>
            </tr>
            </form>
        </table>
        <br />
        <table border="1" cellpadding="2" cellspacing="0" width="100%">
            <tr>
                <td bgcolor="#c0c0c0" align="center">Database</td>
                <td bgcolor="#c0c0c0" align="center">Driver</td>
                <td bgcolor="#c0c0c0" align="center">URL</td>
                <td bgcolor="#c0c0c0" align="center">Notes</td>
            </tr>
            <tr>
                <td>Generic</td>
                <td><a href="javascript:completeFields('sun.jdbc.odbc.JdbcOdbcDriver', 0);">sun.jdbc.odbc.JdbcOdbcDriver</a></td>
                <td><a href="javascript:completeFields('jdbc:odbc:database', 1);">jdbc:odbc:database</a></td>
                <td>Can be found at <nobr><a href="http://java.sun.com">Sun website</a></nobr></td>
            </tr>
            <tr>
                <td>Generic Extended</td>
                <td><a href="javascript:completeFields('sun.jdbc.odbc.JdbcOdbcDriver', 0);">sun.jdbc.odbc.JdbcOdbcDriver</a></td>
                <td><a href="javascript:completeFields('jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=path_to_mdb_file', 1);">jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=path_to_mdb_file</a></td>
                <td>Can be found at <nobr><a href="http://java.sun.com">Sun website</a></nobr></td>
            </tr>
            <tr>
                <td>MySQL</td>
                <td><a href="javascript:completeFields('com.caucho.jdbc.mysql.Driver', 0);">com.caucho.jdbc.mysql.Driver</a></td>
                <td><a href="javascript:completeFields('jdbc:mysql-caucho://host:port/database', 1);">jdbc:mysql-caucho://host:port/database</a></td>
                <td>Can be found at <nobr><a href="http://www.caucho.com/projects/index.xtp">Caucho Technology</a></nobr><br />Default port : 3306</td>
            </tr>
            <tr>
                <td>PostgreSQL</td>
                <td><a href="javascript:completeFields('org.postgresql.Driver', 0);">org.postgresql.Driver</a></td>
                <td><a href="javascript:completeFields('jdbc:postgresql:database', 1);">jdbc:postgresql:database</a><br />
                    <a href="javascript:completeFields('jdbc:postgresql://host/database', 1);">jdbc:postgresql://host/database</a><br />
                    <a href="javascript:completeFields('jdbc:postgresql://host:port/database', 1);">jdbc:postgresql://host:port/database</a></td>
                <td>Can be found at <nobr><a href="http://jdbc.postgresql.org/download.html">PostgreSQL website</a></nobr></td>
            </tr>
            <tr>
                <td>DB2</td>
                <td><a href="javascript:completeFields('COM.ibm.db2.jdbc.app.DB2Driver', 0);">COM.ibm.db2.jdbc.app.DB2Driver</a></td>
                <td><a href="javascript:completeFields('jdbc:db2:database', 1);">jdbc:db2:database</a></td>
                <td>Can be found at <nobr><a href="http://www.ibm.com">IBM website</a></nobr></td>
            </tr>
            <tr>
                <td>DB2</td>
                <td><a href="javascript:completeFields('COM.ibm.db2.jdbc.net.DB2Driver', 0);">COM.ibm.db2.jdbc.net.DB2Driver</a></td>
                <td><a href="javascript:completeFields('jdbc:db2:host:database', 1);">jdbc:db2:host:database</a></td>
                <td>Can be found at <nobr><a href="http://www.ibm.com">IBM website</a></nobr><br />Default port : 50000</td>
            </tr>
            <tr>
                <td>Oracle</td>
                <td><a href="javascript:completeFields('oracle.jdbc.driver.OracleDriver', 0);">oracle.jdbc.driver.OracleDriver</a></td>
                <td><a href="javascript:completeFields('jdbc:oracle:oci8:@TNSNames_Entry', 1);">jdbc:oracle:oci8:@TNSNames_Entry</a><br />
                    <a href="javascript:completeFields('jdbc:oracle:thin:@host:port:SID', 1);">jdbc:oracle:thin:@host:port:SID</a></td>
                <td>Can be found at <nobr><a href="http://www.oracle.com">Oracle website</a></nobr><br />Default port : 1521</td>
            </tr>
        </table>
    </center>
<%
    }else{
        try{
            // trying to load driver.
            Class.forName(request.getParameter("driver").trim());
            try{
                //driver loaded successfully - trying to get connection.
                String url = request.getParameter("url").trim();
                String login = request.getParameter("login").trim();
                String password = request.getParameter("password").trim();
                Connection Conn = DriverManager.getConnection(url, login, password);
                //connection ok. lets save it in session.
                session.putValue("connection", Conn);
                session.putValue("justConnected", "true");
            }catch(SQLException e){
                    //connection failed. Lets explain user why it is failed(these messages depends on driver implementation).
                out.println("SQLException: " + e.getMessage() + "<br />");
                out.println("SQLState:     " + e.getSQLState() + "<br />");
                out.println("VendorError:  " + e.getErrorCode() + "<br />");
%>
    <center>
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td class="main">Back to the <a href="index.jsp">main</a> page</td>
            </tr>
        </table>
    </center>
<%
            }
        }catch(Exception e){
            //driver loading failed.
            out.println("Unable to load driver.<br />");
%>
    <center>
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td class="main">Back to the <a href="index.jsp">main</a> page</td>
            </tr>
        </table>
    </center>
<%
        }
    }
}
//lets check connection is established.
if(session.getValue("connection") != null){
    Connection Conn = (Connection) session.getValue("connection");
    //should we show database info ?
    if("1".equalsIgnoreCase(request.getParameter("dbmsInfo"))){
        //yes. let's show it.
        String str = null;
%>
    <center>
        <table border="1" cellpadding="5" cellspacing="0">
            <tr>
                <td class="tableHeader" width="25%">Database product name :</td>
                <td width="75%"><%= Conn.getMetaData().getDatabaseProductName() %></td>
            </tr>
            <tr>
                <td class="tableHeader">Database product version :</td>
                <td><%= Conn.getMetaData().getDatabaseProductVersion() %></td>
            </tr>
            <tr>
                <td class="tableHeader">Database is read-only :</td>
                <td><%= Conn.getMetaData().isReadOnly() %></td>
            </tr>
<%
        int maxConn = Conn.getMetaData().getMaxConnections();
%>
            <tr>
                <td class="tableHeader">Maximum active connections allowed :</td>
                <td><% if(maxConn > 0){out.println(maxConn);}else{out.println("unlimited or the limit is not known");} %></td>
            </tr>
            <tr>
                <td class="tableHeader">Database transaction isolation level :</td>
                <td><%= Conn.getMetaData().getDefaultTransactionIsolation() %></td>
            </tr>
            <tr>
                <td class="tableHeader">Multiple ResultSet from a single execution :</td>
                <td><%= Conn.getMetaData().supportsMultipleResultSets() %></td>
            </tr>
            <tr>
                <td class="tableHeader">Escape simbols :</td>
                <td><%= Conn.getMetaData().getSearchStringEscape() %></td>
            </tr>
            <tr>
                <td class="tableHeader">Transaction support :</td>
                <td><%= Conn.getMetaData().supportsTransactions() %></td>
            </tr>
            <tr>
                <td class="tableHeader">"GROUP BY" support :</td>
                <td><%= Conn.getMetaData().supportsGroupBy() %></td>
            </tr>
            <tr>
                <td class="tableHeader">Escape symbols in LIKE support :</td>
                <td><%= Conn.getMetaData().supportsLikeEscapeClause() %></td>
            </tr>
            <tr>
                <td class="tableHeader">"UNION" support :</td>
                <td><%= Conn.getMetaData().supportsUnion() %></td>
            </tr>
<%
        str = Conn.getMetaData().getStringFunctions();
        int indexS = 0, indexE = 0;
        indexE = str.indexOf(',', indexS);
        while(indexE != -1){
            str = str.substring(0, indexE) + ", " + str.substring(indexE+1, str.length());
            indexS = indexE+2;
            indexE = str.indexOf(',', indexS);
        }
%>
            <tr>
                <td class="tableHeader">String functions supported :</td>
                <td><%= str %></td>
            </tr>
<%
        str = Conn.getMetaData().getTimeDateFunctions();
        indexS = 0;
        indexE = 0;
        indexE = str.indexOf(',', indexS);
        while(indexE != -1){
            str = str.substring(0, indexE) + ", " + str.substring(indexE+1, str.length());
            indexS = indexE+2;
            indexE = str.indexOf(',', indexS);
        }
%>
            <tr>
                <td class="tableHeader">Date &amp; time functions supported :</td>
                <td><%= str %></td>
            </tr>
<%
        str = Conn.getMetaData().getSystemFunctions();
        indexS = 0;
        indexE = 0;
        indexE = str.indexOf(',', indexS);
        while(indexE != -1){
            str = str.substring(0, indexE) + ", " + str.substring(indexE+1, str.length());
            indexS = indexE+2;
            indexE = str.indexOf(',', indexS);
        }
%>
            <tr>
                <td class="tableHeader">System functions supported :</td>
                <td><%= str %></td>
            </tr>
<%
        str = Conn.getMetaData().getSQLKeywords();
        indexS = 0;
        indexE = 0;
        indexE = str.indexOf(',', indexS);
        while(indexE != -1){
            str = str.substring(0, indexE) + ", " + str.substring(indexE+1, str.length());
            indexS = indexE+2;
            indexE = str.indexOf(',', indexS);
        }
%>
            <tr>
                <td class="tableHeader">Database's SQL keywords that are NOT also SQL92 keywords :</td>
                <td><%= str %></td>
            </tr>
        </table>
    </center>
<%
    }
    //let's check if we have any query to execute.
    if("false".equalsIgnoreCase((String)session.getValue("justConnected")) && request.getParameter("query") != null && request.getParameter("query").toString().trim().length() > 0){
        //yes.
        try{
            Statement st = Conn.createStatement();
            query = request.getParameter("query").trim();
            boolean resultSetIsAvailable;
            boolean moreResultsAvailable;
            int i = 0;
            int res = 0;
            String result = new String("");
            Vector batchQuery = new Vector();
            //let's check user whant query to be parsed to subqueries and executed one-by-one.
            if("1".equalsIgnoreCase(request.getParameter("parseQuery"))){
                int lastMatch = 0;
                if(query.charAt(query.length()-1) != QUERY_DELIMITER)
                    query = query.concat(";");
                boolean inside = false;
                for(int j = 0; j < query.length(); j++){
                    if(query.charAt(j) == '\''){
                    if(query.charAt(j-1) != '\\')
                        inside = !inside;
                    }else{
                        if(query.charAt(j) == ';' && !inside){
                            String subquery;
                            if(lastMatch != 0)
                                subquery = query.substring(lastMatch+1, j).trim();
                            else
                                subquery = query.substring(lastMatch, j).trim();
                            batchQuery.add(subquery);
                            lastMatch = j;
                        }
                    }
                }
            }else{
                batchQuery.add(query);
            }
            for(int j = 0; j < batchQuery.size(); j++){
                resultSetIsAvailable = st.execute((String)batchQuery.get(j));
                //should we show query results ? ...
                if("1".equalsIgnoreCase(request.getParameter("showResults"))){
                    //yes. lets show them.
                    ResultSet rs = null;
                    for(moreResultsAvailable = true; moreResultsAvailable;){
                        if(resultSetIsAvailable && (rs = st.getResultSet()) != null){
                            ResultSetMetaData rsmd = rs.getMetaData();
                            int numCols = rsmd.getColumnCount();
%>
Executed query : <b><%= (String)batchQuery.get(j) %></b><br /><br />
    <center>
        <table border="1" cellpadding="5" cellspacing="0">
            <tr>
<%
                            for(i = 1; i <= numCols; i++){
%>
                <td class="tableHeader" align="center"><%= rsmd.getColumnLabel(i) %></td>
<%
                            }
%>
            </tr>
<%
                            if("1".equalsIgnoreCase(request.getParameter("colsInfo"))){
%>
            <tr>
<%
                                for (i = 1; i <= numCols; i++){
%>
                <td class="tableHeaderLight" align="center"><%= rsmd.getColumnTypeName(i) %>(<%= rsmd.getColumnDisplaySize(i) %>)/<% if(rsmd.isNullable(i) == rsmd.columnNullable){ out.println("null"); }else{ out.println("not null"); } %></td>
<%
                                }
%>
            </tr>
<%
                            }
                            while(rs.next()){
%>
            <tr>
<%
                                for(i = 1; i <= numCols; i++){
                                    result = rs.getString(i);
                                    if(result != null)
                                        result = new String(result.getBytes(dbEnc), outEnc);
                                    else
                                        result = "";
%>
                <td class="main" align="center"><% if(result.trim().length() > 0) {out.println(result);} else { %>&nbsp;<% } %></td>
<%
                                }
%>
            </tr>
<%
                            }
%>
        </table>
    </center>
    <hr />
<%
                        }else{
                            if((res = st.getUpdateCount()) != -1){
%>
    <table border="0" cellpadding="0" cellspacing="0">
        <tr>
            <td class="main"><%= res %> row(s) affected.</td>
        </tr>
    </table>
<%
                            }else{
                                moreResultsAvailable = false;
                            }
                        }
                        if(moreResultsAvailable){
                            resultSetIsAvailable = st.getMoreResults();
                                if(!resultSetIsAvailable)
                                    moreResultsAvailable = false;
                        }
                    }
                }
            }
            st.close();
        }catch(SQLException e){
            //query execution error caught. Lets explain the user what happend(These messages depends on driver implementation).
            out.println("SQLException: " + e.getMessage() + "<br />");
            out.println("SQLState:     " + e.getSQLState() + "<br />");
            out.println("VendorError:  " + e.getErrorCode() + "<br />");
        }
    }
    //should we disconnect from the database ?
    if(request.getParameter("disc") != null && request.getParameter("disc").toString().equalsIgnoreCase("true")){
        //yse. dropping connection.
        Conn.close();
        //dropping session variables.
        session.putValue("connected", null);
        session.putValue("connection", null);
%>
    <center>
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td class="main">You are disconnected</td>
            </tr>
            <tr>
                <td class="main">Back to the <a href="index.jsp">main</a> page</td>
            </tr>
        </table>
    </center>
<%
    }else{
%>
    <center>
        <table border="0" cellpadding="0" cellspacing="0">
            <form action="index.jsp" method="post">
            <tr>
                <td class="main" align="right"><nobr>disconnect :</nobr></td>
                <td>&nbsp;&nbsp;</td>
                <td class="main" align="left"><input tabindex="3" type="Checkbox" name="disc" value="true"></td>
                <td colspan="2">&nbsp;</td>
            </tr>
            <tr>
                <td class="main" align="right">Query :</td>
                <td class="main">&nbsp;</td>
                <td class="main" align="left"><textarea tabindex="1" cols="50" rows="10" name="query" wrap="soft"><% if(request.getParameter("saveInput") != null && request.getParameter("saveInput").equalsIgnoreCase("1")) { out.println(query); } %></textarea></td>
                <td class="main">&nbsp;&nbsp;</td>
                <td class="main">
                    <table border="0" cellpadding="0" cellspacing="0">
                        <tr>
                            <td class="main" align="right">pageEncoding :</td>
                            <td class="main">&nbsp;&nbsp;</td>
                            <td class="main" align="left">
                                <select name="pageEnc" tabindex="4">
<%
        for(int i = 0; i < pageEncodings.length; i++){
%>
                                    <option value="<%= pageEncodings[i] %>"<% if (pageEnc.equalsIgnoreCase(pageEncodings[i])){ out.println(" selected"); } %>><%= pageEncodings[i] %></option>
<%
        }
%>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td class="main" align="right">dbEncoding :</td>
                            <td class="main">&nbsp;&nbsp;</td>
                            <td class="main" align="left">
                                <select name="dbEnc" tabindex="5">
<%
        for(int i = 0; i < javaEncodings.length; i++){
%>
                                    <option value="<%= javaEncodings[i] %>"<% if (dbEnc.equalsIgnoreCase(javaEncodings[i])){ out.println(" selected"); } %>><%= javaEncodings[i] %></option>
<%
        }
%>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td class="main" align="right">outEncoding :</td>
                            <td class="main">&nbsp;&nbsp;</td>
                            <td class="main" align="left">
                                <select name="outEnc" tabindex="6">
<%
        for(int i = 0; i < javaEncodings.length; i++){
%>
                                    <option value="<%= javaEncodings[i] %>"<% if (outEnc.equalsIgnoreCase(javaEncodings[i])){ out.println(" selected"); } %>><%= javaEncodings[i] %></option>
<%
        }
%>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td class="main" align="right">Save input :</td>
                            <td class="main">&nbsp;&nbsp;</td>
                            <td class="main" align="left"><input tabindex="7" type="Checkbox" name="saveInput" value="1" <% if ("true".equalsIgnoreCase((String)session.getValue("justConnected")) || "1".equalsIgnoreCase(request.getParameter("saveInput"))){ out.println(" checked"); } %>></td>
                        </tr>
                        <tr>
                            <td class="main" align="right">Show results :</td>
                            <td class="main">&nbsp;&nbsp;</td>
                            <td class="main" align="left"><input tabindex="8" type="Checkbox" name="showResults" value="1" <% if ("true".equalsIgnoreCase((String)session.getValue("justConnected")) || "1".equalsIgnoreCase(request.getParameter("showResults"))){ out.println(" checked"); } %>></td>
                        </tr>
                        <tr>
                            <td class="main" align="right">Parse query :</td>
                            <td class="main">&nbsp;&nbsp;</td>
                            <td class="main" align="left"><input tabindex="9" type="Checkbox" name="parseQuery" value="1" <% if ("true".equalsIgnoreCase((String)session.getValue("justConnected")) || "1".equalsIgnoreCase(request.getParameter("parseQuery"))){ out.println(" checked"); } %>></td>
                        </tr>
                        <tr>
                            <td class="main" align="right">Show columns info :</td>
                            <td class="main">&nbsp;&nbsp;</td>
                            <td class="main" align="left"><input tabindex="10" type="Checkbox" name="colsInfo" value="1" <% if ("1".equalsIgnoreCase(request.getParameter("colsInfo"))){ out.println(" checked"); } %>></td>
                        </tr>
                        <tr>
                            <td class="main" align="right">Show DBMS info :</td>
                            <td class="main">&nbsp;&nbsp;</td>
                            <td class="main" align="left"><input tabindex="10" type="Checkbox" name="dbmsInfo" value="1" <% if ("1".equalsIgnoreCase(request.getParameter("dbmsInfo"))){ out.println(" checked"); } %>></td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td class="main" colspan="2">&nbsp;</td>
                <td class="main" align="left"><input tabindex="2" type="Submit" value="Submit" class="main"></td>
                <td class="main" colspan="2">&nbsp;</td>
            </tr>
            </form>
        </table>
    </center>
<%
        session.putValue("justConnected", "false");
    }
}
%>
    <br />
    <a href="http://www.zaval.org" class="copy" title="http://www.zaval.org"><div class="copy" align="center">Zaval Creative Engineering Group, 2001</div></a>
</body>
</html>
